From 0f8c1d21e51e0338a10352df69cfdf57bab272d6 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Jun 21 2017 13:41:17 +0000
Subject: [PATCH 879/1001] Add a timeout to the request call in some widgets


---

diff --git a/hubs/widgets/bugzilla/__init__.py b/hubs/widgets/bugzilla/__init__.py
index 1c37299..ae09257 100644
--- a/hubs/widgets/bugzilla/__init__.py
+++ b/hubs/widgets/bugzilla/__init__.py
@@ -1,5 +1,8 @@
 from __future__ import unicode_literals
 
+import logging
+import json
+
 import requests
 import pkgwat.api
 
@@ -8,6 +11,9 @@ from hubs.widgets.base import Widget, WidgetView
 from hubs.widgets.caching import CachedFunction, cache
 
 
+log = logging.getLogger('hubs.widgets')
+
+
 PKGDB_URL = "https://admin.fedoraproject.org/pkgdb/api/packager/package"
 
 
@@ -102,8 +108,20 @@ class GetIssues(CachedFunction):
         # request is waaaay too long to be run on each incoming bug message.
         def get_owned():
             url = "/".join([PKGDB_URL, username])
-            response = requests.get(url)
-            data = response.json()
+            try:
+                response = requests.get(url, timeout=5)
+            except (requests.exceptions.ConnectionError,
+                    requests.exceptions.Timeout):
+                log.warning("Could not get the list of owned packages for %s",
+                            username)
+                return []
+            try:
+                data = response.json()
+            except json.decoder.JSONDecodeError:
+                log.warning(
+                    "Invalid JSON response getting the list of packages "
+                    "owned by %s: %s", username, response.text)
+                return []
             owned = data['point of contact'] + data['co-maintained']
             return [p['name'] for p in owned]
         owned_cache_key = ":".join(["owned_packages", username])
diff --git a/hubs/widgets/fedmsgstats/__init__.py b/hubs/widgets/fedmsgstats/__init__.py
index 70f545e..3e5ab7c 100644
--- a/hubs/widgets/fedmsgstats/__init__.py
+++ b/hubs/widgets/fedmsgstats/__init__.py
@@ -57,11 +57,14 @@ class GetStats(CachedFunction):
         username = self.instance.config["username"]
         url = "https://apps.fedoraproject.org/datagrepper/raw?user={username}"
         url = url.format(username=username)
-        response = requests.get(url)
         try:
+            response = requests.get(url, timeout=5)
             fedmsgs = response.json()['total']
-        except json.decoder.JSONDecodeError:
-            fedmsgs = 0
+        except (requests.exceptions.Timeout, json.decoder.JSONDecodeError):
+            fedmsgs = None
+            fedmsgs_text = "?"
+        else:
+            fedmsgs_text = commas(fedmsgs)
         sub_list = []
         for assoc in self.instance.hub.associations:
             if assoc.user:
@@ -69,7 +72,7 @@ class GetStats(CachedFunction):
         subscribers = [u.username for u in self.instance.hub.subscribers]
         return dict(
             fedmsgs=fedmsgs,
-            fedmsgs_text=commas(fedmsgs),
+            fedmsgs_text=fedmsgs_text,
             subscribers=subscribers,
             subscribed_to=sub_list,
             subscribers_text=commas(len(subscribers)),
@@ -78,5 +81,4 @@ class GetStats(CachedFunction):
 
     def should_invalidate(self, message):
         usernames = fedmsg.meta.msg2usernames(message, **fedmsg_config)
-        username = self.instance.config['username']
-        return username in usernames
+        return (self.instance.config['username'] in usernames)

